## cglm 0.7.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.2)
project(cglm VERSION 0.7.6 LANGUAGES C)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED YES)
set(DEFAULT_BUILD_TYPE "Release")

set(CGLM_BUILD)
option(CGLM_SHARED "Shared build" ON)
option(CGLM_STATIC "Static build" OFF)
option(CGLM_USE_C99 "" OFF)
option(CGLM_USE_TEST "Enable Tests" OFF)

if(NOT CGLM_STATIC AND CGLM_SHARED)
  set(CGLM_BUILD SHARED)
else(CGLM_STATIC)
  set(CGLM_BUILD STATIC)
endif()

if(CGLM_USE_C99)
  set(C_STANDARD 99)
endif()

if(MSVC)
	add_definitions(-DNDEBUG -D_WINDOWS -D_USRDLL -DCGLM_EXPORTS -DCGLM_DLL)
	add_compile_options(/W3 /Ox /Gy /Oi /TC)
else()
  add_compile_options(-Wall -Werror -O3)
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

include(GNUInstallDirs)

set(CPACK_PROJECT_NAME ${PROJECT_NAME})
set(CPACK_PROJECT_VERSION ${PROJECT_VERSION})
include(CPack)

# Target Start
add_library(${PROJECT_NAME}
  ${CGLM_BUILD}
  src/euler.c
  src/affine.c
  src/io.c
  src/quat.c
  src/cam.c
  src/vec2.c
  src/vec3.c
  src/vec4.c
  src/mat2.c
  src/mat3.c
  src/mat4.c
  src/plane.c
  src/frustum.c
  src/box.c
  src/project.c
  src/sphere.c
  src/ease.c
  src/curve.c
  src/bezier.c
  src/ray.c
  )

set_target_properties(${PROJECT_NAME} PROPERTIES
                              VERSION ${PROJECT_VERSION} 
                            SOVERSION ${PROJECT_VERSION_MAJOR})

target_include_directories(${PROJECT_NAME}
    PUBLIC 
        $<INSTALL_INTERFACE:include>    
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/src
)

# Test Configuration
if(CGLM_USE_TEST)
  include(CTest)
  enable_testing()
  add_subdirectory(test)
endif()

# Install 
install(TARGETS ${PROJECT_NAME}
        EXPORT  ${PROJECT_NAME}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(DIRECTORY include/${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        PATTERN ".*" EXCLUDE)

# Config
export(TARGETS ${PROJECT_NAME}
       NAMESPACE ${PROJECT_NAME}::
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
)

install(EXPORT      ${PROJECT_NAME}
        NAMESPACE   ${PROJECT_NAME}::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}/cmake)

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.2)

# List all files containing tests. (Change as needed)
set(TESTFILES
  runner.c
  src/test_euler.c
  src/test_bezier.c
  src/test_cam.c
  src/test_struct.c
  src/test_clamp.c
  src/test_common.c
  src/tests.c
  )

set(TEST_MAIN tests)
set(TEST_RUNNER_PARAMS "")

add_executable(${TEST_MAIN} ${TESTFILES})

target_link_libraries(${TEST_MAIN} PRIVATE cglm m)
target_include_directories(${TEST_MAIN} PRIVATE
  ${CMAKE_CURRENT_LIST_DIR}/include
  ${CMAKE_CURRENT_LIST_DIR}/src
  )

set_target_properties(${TEST_MAIN} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

if(LDFLAGS)
  target_compile_options(${TEST_MAIN} PRIVATE ${LDFLAGS})
endif()

add_test(
    NAME cglm.${TEST_MAIN}
    COMMAND ${TEST_MAIN} ${TEST_RUNNER_PARAMS})

add_custom_target(check
  make
  COMMAND ${CMAKE_CTEST_COMMAND} -V
  DEPENDS cglm)

=== debian/changelog ===
cglm (0.7.6-2) unstable; urgency=medium

  * Re-release to unstable as source-only upload to allow migration to testing

 -- Jordan Justen <jljusten@debian.org>  Wed, 22 Jul 2020 01:27:55 -0700

cglm (0.7.6-1) unstable; urgency=medium

  [ Leon Marz ]
  * Initial release (Closes: #950988)

  [ Jordan Justen ]
  * d/rules: Disable building of static library
  * d/rules: Delete .la files installed by autotools

 -- Leon Marz <lmarz@cs.uni-frankfurt.de>  Wed, 01 Jul 2020 15:45:00 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- --enable-static=no

override_dh_install:
	find debian/tmp/ -name '*.la' -exec rm '{}' ';'
	dh_install -a

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	python3 -m sphinx -b html docs/source \
		$(CURDIR)/debian/libcglm-doc/usr/share/doc/libcglm-doc/html
	rm -f $(CURDIR)/debian/libcglm-doc/usr/share/doc/libcglm-doc/html/.nojekyll
	dh_sphinxdoc
endif

## cglm 0.7.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.8.2)
-project(cglm VERSION 0.7.6 LANGUAGES C)
+project(cglm VERSION 0.7.7 LANGUAGES C)
 
 set(CMAKE_C_STANDARD 11)
 set(CMAKE_C_STANDARD_REQUIRED YES)
@@ -22,8 +22,16 @@
 endif()
 
 if(MSVC)
-	add_definitions(-DNDEBUG -D_WINDOWS -D_USRDLL -DCGLM_EXPORTS -DCGLM_DLL)
-	add_compile_options(/W3 /Ox /Gy /Oi /TC)
+  add_definitions(-DNDEBUG -D_WINDOWS -D_USRDLL -DCGLM_EXPORTS -DCGLM_DLL)
+  add_compile_options(/W3 /Ox /Gy /Oi /TC)
+  
+  # Ref: https://skia.googlesource.com/third_party/sdl/+/refs/heads/master/CMakeLists.txt#225
+  # Make sure /RTC1 is disabled, otherwise it will use functions from the CRT
+  foreach(flag_var
+      CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
+      CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
+    string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
+  endforeach(flag_var)
 else()
   add_compile_options(-Wall -Werror -O3)
 endif()
@@ -64,6 +72,7 @@
   src/curve.c
   src/bezier.c
   src/ray.c
+  src/affine2d.c
   )
 
 set_target_properties(${PROJECT_NAME} PROPERTIES

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 set(TEST_RUNNER_PARAMS "")
 
 add_executable(${TEST_MAIN} ${TESTFILES})
+target_compile_definitions(${TEST_MAIN} PRIVATE CGLM_DEFINE_PRINTS=1)
 
 target_link_libraries(${TEST_MAIN} PRIVATE cglm m)
 target_include_directories(${TEST_MAIN} PRIVATE

=== debian/changelog ===
cglm (0.7.7-1) unstable; urgency=medium

  * New upstream release

 -- Leon Marz <lmarz@cs.uni-frankfurt.de>  Tue, 04 Aug 2020 20:25:00 +0200

cglm (0.7.6-3) unstable; urgency=medium

  * d/rules: Add dh_missing --list-missing (Closes: #966079)

 -- Leon Marz <lmarz@cs.uni-frankfurt.de>  Fri, 24 Jul 2020 13:05:00 +0200

## cglm 0.7.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.8.2)
-project(cglm VERSION 0.7.7 LANGUAGES C)
+project(cglm VERSION 0.7.8 LANGUAGES C)
 
 set(CMAKE_C_STANDARD 11)
 set(CMAKE_C_STANDARD_REQUIRED YES)
@@ -22,7 +22,7 @@
 endif()
 
 if(MSVC)
-  add_definitions(-DNDEBUG -D_WINDOWS -D_USRDLL -DCGLM_EXPORTS -DCGLM_DLL)
+  add_definitions(-DNDEBUG -D_WINDOWS -D_USRDLL)
   add_compile_options(/W3 /Ox /Gy /Oi /TC)
   
   # Ref: https://skia.googlesource.com/third_party/sdl/+/refs/heads/master/CMakeLists.txt#225
@@ -75,6 +75,12 @@
   src/affine2d.c
   )
 
+if(CGLM_SHARED)
+  add_definitions(-DCGLM_EXPORTS)
+else()
+  target_compile_definitions(${PROJECT_NAME} PUBLIC -DCGLM_STATIC)
+endif()
+
 set_target_properties(${PROJECT_NAME} PROPERTIES
                               VERSION ${PROJECT_VERSION} 
                             SOVERSION ${PROJECT_VERSION_MAJOR})

=== debian/changelog ===
cglm (0.7.8-1) unstable; urgency=medium

  * New upstream release

 -- Leon Marz <lmarz@cs.uni-frankfurt.de>  Mon, 17 Aug 2020 10:15:00 +0200

=== debian/control ===
Source: cglm
Priority: optional
Maintainer: Leon Marz <lmarz@cs.uni-frankfurt.de>
Uploaders: Jordan Justen <jljusten@debian.org>
Build-Depends: debhelper-compat (= 13),
               python3-sphinx,
               python3-sphinx-rtd-theme
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/recp/cglm
Vcs-Git: https://salsa.debian.org/debian/cglm.git
Vcs-Browser: https://salsa.debian.org/debian/cglm
Rules-Requires-Root: no

Package: libcglm-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Documentation for the cglm library
 cglm is an optimized 3D math library written in C99 (compatible with C89).
 It is based on the OpenGL Shading Language (GLSL) specification and
 similar to the original glm library except this library is written in C.
 It uses the same header-only approach like glm but also supports
 pre-compield function calls
 .
 This package contains the documentation files in HTML format.

Package: libcglm-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcglm0 (= ${binary:Version}), ${misc:Depends}
Suggests: libcglm-doc (= ${binary:Version})
Description: Development files for the cglm library
 cglm is an optimized 3D math library written in C99 (compatible with C89).
 It is based on the OpenGL Shading Language (GLSL) specification and
 similar to the original glm library except this library is written in C.
 It uses the same header-only approach like glm but also supports
 pre-compield function calls
 .
 Features:
  * array api and struct api, you can use arrays or structs.
  * general prupose matrix operations (mat4, vec3)
  * chain matrix multiplications (square only)
  * affine transforms
  * matrix decomposition (extract rotation, scaling factor)
  * optimized affine transform matrices (mul, rigid-body inverse)
  * camera (lookat)
  * projections (ortho, perspective)
  * quaternions
  * euler angles / yaw-pitch-roll to matrix
  * extract euler angles
  * inline or pre-compiled function call
  * frustum (extract view frustum planes, corners, ...)
  * bounding box (AABB in Frustum (culling), crop, merge, ...)
  * bounding sphere
  * project, unproject
  * easing functions
  * curves
  * curve interpolation helpers (SMC, deCasteljau, ...)
  * and other ...
 .
 This package contains the development header files

Package: libcglm0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Optimized OpenGL Mathematics library for C
 cglm is an optimized 3D math library written in C99 (compatible with C89).
 It is based on the OpenGL Shading Language (GLSL) specification and
 similar to the original glm library except this library is written in C.
 It uses the same header-only approach like glm but also supports
 pre-compield function calls
 .
 This library is designed to be compatible for programming with
 OpenGL/Vulkan applications. It uses a column-major layout for matrices.

## cglm 0.7.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.8.2)
-project(cglm VERSION 0.7.8 LANGUAGES C)
+project(cglm VERSION 0.7.9 LANGUAGES C)
 
 set(CMAKE_C_STANDARD 11)
 set(CMAKE_C_STANDARD_REQUIRED YES)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,11 @@
 add_executable(${TEST_MAIN} ${TESTFILES})
 target_compile_definitions(${TEST_MAIN} PRIVATE CGLM_DEFINE_PRINTS=1)
 
-target_link_libraries(${TEST_MAIN} PRIVATE cglm m)
+if(NOT MSVC)
+  target_link_libraries(${TEST_MAIN} PRIVATE m)
+endif()
+
+target_link_libraries(${TEST_MAIN} PRIVATE cglm)
 target_include_directories(${TEST_MAIN} PRIVATE
   ${CMAKE_CURRENT_LIST_DIR}/include
   ${CMAKE_CURRENT_LIST_DIR}/src

=== debian/changelog ===
cglm (0.7.9-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.1
    - no changes needed
  * Add upstream/metadata

 -- Leon Marz <lmarz@cs.uni-frankfurt.de>  Thu, 19 Nov 2020 09:25:00 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
                python3-sphinx,
                python3-sphinx-rtd-theme
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/recp/cglm
 Vcs-Git: https://salsa.debian.org/debian/cglm.git

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,9 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- --enable-static=no
+
+override_dh_missing-indep:
+	dh_missing --list-missing
 
 override_dh_install:
 	find debian/tmp/ -name '*.la' -exec rm '{}' ';'

## cglm 0.8.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.8.2)
-project(cglm VERSION 0.7.9 LANGUAGES C)
+project(cglm VERSION 0.8.4 LANGUAGES C)
 
 set(CMAKE_C_STANDARD 11)
 set(CMAKE_C_STANDARD_REQUIRED YES)
@@ -18,7 +18,7 @@
 endif()
 
 if(CGLM_USE_C99)
-  set(C_STANDARD 99)
+  set(CMAKE_C_STANDARD 99)
 endif()
 
 if(MSVC)
@@ -73,6 +73,18 @@
   src/bezier.c
   src/ray.c
   src/affine2d.c
+  src/clipspace/persp_lh_zo.c
+  src/clipspace/persp_rh_zo.c
+  src/clipspace/persp_lh_no.c
+  src/clipspace/persp_rh_no.c
+  src/clipspace/ortho_lh_zo.c
+  src/clipspace/ortho_rh_zo.c
+  src/clipspace/ortho_lh_no.c
+  src/clipspace/ortho_rh_no.c
+  src/clipspace/view_lh_zo.c
+  src/clipspace/view_rh_zo.c
+  src/clipspace/view_lh_no.c
+  src/clipspace/view_rh_no.c
   )
 
 if(CGLM_SHARED)
@@ -92,6 +104,11 @@
     PRIVATE
         ${CMAKE_CURRENT_SOURCE_DIR}/src
 )
+
+# Target for header-only usage
+add_library(${PROJECT_NAME}_headers INTERFACE)
+target_include_directories(${PROJECT_NAME}_headers INTERFACE
+  ${CMAKE_CURRENT_SOURCE_DIR}/include)
 
 # Test Configuration
 if(CGLM_USE_TEST)
@@ -117,6 +134,16 @@
 )
 
 install(EXPORT      ${PROJECT_NAME}
+        FILE        "${PROJECT_NAME}Config.cmake"
         NAMESPACE   ${PROJECT_NAME}::
-        DESTINATION ${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}/cmake)
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
 
+set(PACKAGE_NAME ${PROJECT_NAME})
+set(prefix ${CMAKE_INSTALL_PREFIX})
+set(exec_prefix ${CMAKE_INSTALL_PREFIX})
+set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+set(libdir "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
+configure_file(${CMAKE_CURRENT_LIST_DIR}/cglm.pc.in ${CMAKE_BINARY_DIR}/cglm.pc @ONLY)
+
+install(FILES ${CMAKE_BINARY_DIR}/cglm.pc
+  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
cglm (0.8.4-3) unstable; urgency=medium

  * Improve clamp_rounding.patch (Closes: #996711)

 -- Leon Marz <main@lmarz.org>  Wed, 20 Oct 2021 15:49:00 +0200

cglm (0.8.4-2) unstable; urgency=medium

  * Add clamp_rounding.patch (Closes: #996711)

 -- Leon Marz <main@lmarz.org>  Tue, 19 Oct 2021 11:19:00 +0200

cglm (0.8.4-1) unstable; urgency=medium

  * New upstream release
  * Add flt_epsilon.patch to fix test failure on i386 and s390x
  * Bump Standards-Version to 4.6.0
    - no changes needed

 -- Leon Marz <main@lmarz.org>  Thu, 07 Oct 2021 09:55:00 +0200

cglm (0.8.3-1) unstable; urgency=medium

  * New upstream release
  * Change maintainer email address
  * Switch buildsystem to meson

 -- Leon Marz <main@lmarz.org>  Sun, 15 Aug 2021 14:31:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: cglm
 Priority: optional
-Maintainer: Leon Marz <lmarz@cs.uni-frankfurt.de>
+Maintainer: Leon Marz <main@lmarz.org>
 Uploaders: Jordan Justen <jljusten@debian.org>
 Build-Depends: debhelper-compat (= 13),
+               meson,
                python3-sphinx,
                python3-sphinx-rtd-theme
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: libs
 Homepage: https://github.com/recp/cglm
 Vcs-Git: https://salsa.debian.org/debian/cglm.git

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%cglm-$1.tar.gz%" \
   https://github.com/recp/cglm/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## cglm 0.8.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.8.2)
-project(cglm VERSION 0.8.4 LANGUAGES C)
+project(cglm VERSION 0.8.5 LANGUAGES C)
 
 set(CMAKE_C_STANDARD 11)
 set(CMAKE_C_STANDARD_REQUIRED YES)
@@ -47,7 +47,10 @@
 
 set(CPACK_PROJECT_NAME ${PROJECT_NAME})
 set(CPACK_PROJECT_VERSION ${PROJECT_VERSION})
-include(CPack)
+
+if(NOT CPack_CMake_INCLUDED)
+  include(CPack)
+endif()
 
 # Target Start
 add_library(${PROJECT_NAME}
@@ -97,6 +100,12 @@
                               VERSION ${PROJECT_VERSION} 
                             SOVERSION ${PROJECT_VERSION_MAJOR})
 
+if(WIN32)
+  # Because SOVERSION has no effect to file naming on Windows
+  set_target_properties(${PROJECT_NAME} PROPERTIES
+    RUNTIME_OUTPUT_NAME ${PROJECT_NAME}-${PROJECT_VERSION_MAJOR})
+endif()
+
 target_include_directories(${PROJECT_NAME}
     PUBLIC 
         $<INSTALL_INTERFACE:include>    
@@ -122,7 +131,7 @@
         EXPORT  ${PROJECT_NAME}
         LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
         ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-        RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR})
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 install(DIRECTORY include/${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
         PATTERN ".*" EXCLUDE)
@@ -143,6 +152,7 @@
 set(exec_prefix ${CMAKE_INSTALL_PREFIX})
 set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
 set(libdir "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
+set(PACKAGE_VERSION "${PROJECT_VERSION}")
 configure_file(${CMAKE_CURRENT_LIST_DIR}/cglm.pc.in ${CMAKE_BINARY_DIR}/cglm.pc @ONLY)
 
 install(FILES ${CMAKE_BINARY_DIR}/cglm.pc

=== debian/changelog ===
cglm (0.8.5-1) unstable; urgency=medium

  * New upstream release
  * d/patches: Remove flt_epsilon.patch
  * d/copyright: Update copyright year

 -- Leon Marz <main@lmarz.org>  Tue, 22 Mar 2022 10:14:00 +0100

## cglm 0.8.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,10 @@
 cmake_minimum_required(VERSION 3.8.2)
-project(cglm VERSION 0.8.5 LANGUAGES C)
+project(cglm
+  VERSION 0.8.6
+  HOMEPAGE_URL https://github.com/recp/cglm
+  DESCRIPTION "OpenGL Mathematics (glm) for C"
+  LANGUAGES C
+)
 
 set(CMAKE_C_STANDARD 11)
 set(CMAKE_C_STANDARD_REQUIRED YES)
@@ -61,8 +66,11 @@
   src/quat.c
   src/cam.c
   src/vec2.c
+  src/ivec2.c
   src/vec3.c
+  src/ivec3.c
   src/vec4.c
+  src/ivec4.c
   src/mat2.c
   src/mat3.c
   src/mat4.c
@@ -76,18 +84,20 @@
   src/bezier.c
   src/ray.c
   src/affine2d.c
+  src/clipspace/ortho_lh_no.c
+  src/clipspace/ortho_lh_zo.c
+  src/clipspace/ortho_rh_no.c
+  src/clipspace/ortho_rh_zo.c
+  src/clipspace/persp_lh_no.c
   src/clipspace/persp_lh_zo.c
+  src/clipspace/persp_rh_no.c
   src/clipspace/persp_rh_zo.c
-  src/clipspace/persp_lh_no.c
-  src/clipspace/persp_rh_no.c
-  src/clipspace/ortho_lh_zo.c
-  src/clipspace/ortho_rh_zo.c
-  src/clipspace/ortho_lh_no.c
-  src/clipspace/ortho_rh_no.c
+  src/clipspace/view_lh_no.c
   src/clipspace/view_lh_zo.c
+  src/clipspace/view_rh_no.c
   src/clipspace/view_rh_zo.c
-  src/clipspace/view_lh_no.c
-  src/clipspace/view_rh_no.c
+  src/clipspace/project_no.c
+  src/clipspace/project_zo.c
   )
 
 if(CGLM_SHARED)
@@ -147,13 +157,7 @@
         NAMESPACE   ${PROJECT_NAME}::
         DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
 
-set(PACKAGE_NAME ${PROJECT_NAME})
-set(prefix ${CMAKE_INSTALL_PREFIX})
-set(exec_prefix ${CMAKE_INSTALL_PREFIX})
-set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
-set(libdir "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
-set(PACKAGE_VERSION "${PROJECT_VERSION}")
-configure_file(${CMAKE_CURRENT_LIST_DIR}/cglm.pc.in ${CMAKE_BINARY_DIR}/cglm.pc @ONLY)
+configure_file(cglm.pc.in cglm.pc @ONLY)
 
 install(FILES ${CMAKE_BINARY_DIR}/cglm.pc
   DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,10 @@
   src/test_euler.c
   src/test_bezier.c
   src/test_cam.c
+  src/test_cam_lh_zo.c
+  src/test_cam_rh_zo.c
+  src/test_cam_lh_no.c
+  src/test_cam_rh_no.c
   src/test_struct.c
   src/test_clamp.c
   src/test_common.c

=== debian/changelog ===
cglm (0.8.6-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.1
    - no changes needed

 -- Leon Marz <main@lmarz.org>  Sun, 23 Oct 2022 20:00:00 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                meson,
                python3-sphinx,
                python3-sphinx-rtd-theme
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/recp/cglm
 Vcs-Git: https://salsa.debian.org/debian/cglm.git

## cglm 0.8.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.8.2)
 project(cglm
-  VERSION 0.8.6
+  VERSION 0.8.8
   HOMEPAGE_URL https://github.com/recp/cglm
   DESCRIPTION "OpenGL Mathematics (glm) for C"
   LANGUAGES C
@@ -159,5 +159,5 @@
 
 configure_file(cglm.pc.in cglm.pc @ONLY)
 
-install(FILES ${CMAKE_BINARY_DIR}/cglm.pc
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cglm.pc
   DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
cglm (0.8.8-1) unstable; urgency=medium

  * New upstream release
  * d/control: janitor: Apply multi-arch hints
  * d/patches: Remove (fixed by upstream)
  * d/control: Update feature list in description
  * d/watch: Use the example from uscan(1)
  * d/control: Bump Standards-Version to 4.6.2
    - no changes needed

 -- Leon Marz <main@lmarz.org>  Wed, 21 Dec 2022 17:34:00 +0200

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/recp/cglm/tags \
    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## cglm 0.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.8.2)
 project(cglm
-  VERSION 0.8.8
+  VERSION 0.9.0
   HOMEPAGE_URL https://github.com/recp/cglm
   DESCRIPTION "OpenGL Mathematics (glm) for C"
   LANGUAGES C
@@ -15,6 +15,11 @@
 option(CGLM_STATIC "Static build" OFF)
 option(CGLM_USE_C99 "" OFF)
 option(CGLM_USE_TEST "Enable Tests" OFF)
+
+if(CMAKE_SYSTEM_NAME STREQUAL WASI)
+  set(CGLM_STATIC ON CACHE BOOL "Static option" FORCE)
+  set(CGLM_SHARED OFF CACHE BOOL "Shared option" FORCE)
+endif()
 
 if(NOT CGLM_STATIC AND CGLM_SHARED)
   set(CGLM_BUILD SHARED)
@@ -41,7 +46,9 @@
   add_compile_options(-Wall -Werror -O3)
 endif()
 
-if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+get_directory_property(hasParent PARENT_DIRECTORY)
+
+if(NOT hasParent AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   message(STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
   set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE STRING "Choose the type of build." FORCE)
   # Set the possible values of build type for cmake-gui
@@ -157,6 +164,20 @@
         NAMESPACE   ${PROJECT_NAME}::
         DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
 
+set(PACKAGE_NAME ${PROJECT_NAME})
+set(prefix ${CMAKE_INSTALL_PREFIX})
+set(exec_prefix ${CMAKE_INSTALL_PREFIX})
+if (IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
+  set(includedir "${CMAKE_INSTALL_INCLUDEDIR}")
+else()
+  set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+endif()
+if (IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
+  set(libdir "${CMAKE_INSTALL_LIBDIR}")
+else()
+  set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
+endif()
+set(PACKAGE_VERSION "${PROJECT_VERSION}")
 configure_file(cglm.pc.in cglm.pc @ONLY)
 
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cglm.pc

=== debian/changelog ===
cglm (0.9.0-2) unstable; urgency=medium

  * Fix FTBFS
    - Add fix-glm_arch_print_name-1.patch
    - Add fix-glm_arch_print_name-2.patch

 -- Leon Marz <main@lmarz.org>  Thu, 15 Jun 2023 10:25:00 +0200

cglm (0.9.0-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: Update copyright year

 -- Leon Marz <main@lmarz.org>  Tue, 13 Jun 2023 17:41:00 +0200

## cglm 0.9.1

=== debian/changelog ===
cglm (0.9.1-1) unstable; urgency=medium

  * New upstream release
  * d/patches: Remove (all patches upstream)

 -- Leon Marz <main@lmarz.org>  Wed, 16 Aug 2023 18:52:55 +0100

## cglm 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.8.2)
 project(cglm
-  VERSION 0.9.0
+  VERSION 0.9.2
   HOMEPAGE_URL https://github.com/recp/cglm
   DESCRIPTION "OpenGL Mathematics (glm) for C"
   LANGUAGES C
@@ -43,7 +43,7 @@
     string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
   endforeach(flag_var)
 else()
-  add_compile_options(-Wall -Werror -O3)
+  add_compile_options(-Wall -O3)
 endif()
 
 get_directory_property(hasParent PARENT_DIRECTORY)
@@ -79,8 +79,14 @@
   src/vec4.c
   src/ivec4.c
   src/mat2.c
+  src/mat2x3.c
+  src/mat2x4.c
   src/mat3.c
+  src/mat3x2.c
+  src/mat3x4.c
   src/mat4.c
+  src/mat4x2.c
+  src/mat4x3.c
   src/plane.c
   src/frustum.c
   src/box.c

=== debian/changelog ===
cglm (0.9.2-1) unstable; urgency=medium

  * New upstream release
  * Update symbols file
  * d/copyright: Update copyright year

 -- Leon Marz <main@lmarz.org>  Thu, 01 Feb 2024 11:42:45 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                meson,
                python3-sphinx,
                python3-sphinx-rtd-theme
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/recp/cglm
 Vcs-Git: https://salsa.debian.org/debian/cglm.git
@@ -17,6 +17,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
+Multi-Arch: foreign
 Description: Documentation for the cglm library
  cglm is an optimized 3D math library written in C99 (compatible with C89).
  It is based on the OpenGL Shading Language (GLSL) specification and
@@ -40,10 +41,14 @@
  pre-compield function calls
  .
  Features:
-  * array api and struct api, you can use arrays or structs.
-  * general prupose matrix operations (mat4, vec3)
-  * chain matrix multiplications (square only)
-  * affine transforms
+  * scalar and simd (sse, avx, neon...) optimizations
+  * option to use different clipspaces e.g. Left Handed, Zero-to-One...
+    (currrently right handed negative-one is default)
+  * array API and struct API, you can use arrays or structs.
+  * general purpose matrix operations (mat4, mat3)
+  * chain matrix multiplication (square only)
+  * general purpose vector operations (cross, dot, rotate, proj, angle...)
+  * affine transformations
   * matrix decomposition (extract rotation, scaling factor)
   * optimized affine transform matrices (mul, rigid-body inverse)
   * camera (lookat)
@@ -52,14 +57,17 @@
   * euler angles / yaw-pitch-roll to matrix
   * extract euler angles
   * inline or pre-compiled function call
-  * frustum (extract view frustum planes, corners, ...)
-  * bounding box (AABB in Frustum (culling), crop, merge, ...)
+  * frustum (extract view frustum planes, corners...)
+  * bounding box (AABB in Frustum (culling), crop, merge...)
   * bounding sphere
   * project, unproject
   * easing functions
   * curves
-  * curve interpolation helpers (SMC, deCasteljau, ...)
-  * and other ...
+  * curve interpolation helpers (SMC, deCasteljau...)
+  * helpers to convert cglm types to Apple's simd library to pass cglm types to
+    Metal GL without packing them on both sides
+  * ray intersection helpers
+  * and others...
  .
  This package contains the development header files

=== debian/rules ===
--- 
+++ 
@@ -3,17 +3,13 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with sphinxdoc
+	dh $@ --buildsystem=meson --with sphinxdoc
 
 override_dh_auto_configure:
-	dh_auto_configure -- --enable-static=no
+	dh_auto_configure --buildsystem=meson -- -Dbuild_tests=true
 
 override_dh_missing-indep:
 	dh_missing --list-missing
-
-override_dh_install:
-	find debian/tmp/ -name '*.la' -exec rm '{}' ';'
-	dh_install -a
 
 override_dh_sphinxdoc:
 ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))

## cglm 0.9.4

=== debian/changelog ===
cglm (0.9.4-1) unstable; urgency=medium

  * New upstream release
  * Update symbols file

 -- Leon Marz <main@lmarz.org>  Fri, 19 Apr 2024 14:40:00 +0200

## cglm 0.9.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-cmake_minimum_required(VERSION 3.8.2)
+cmake_minimum_required(VERSION 3.13)
 project(cglm
-  VERSION 0.9.2
+  VERSION 0.9.6
   HOMEPAGE_URL https://github.com/recp/cglm
   DESCRIPTION "OpenGL Mathematics (glm) for C"
   LANGUAGES C
@@ -32,18 +32,23 @@
 endif()
 
 if(MSVC)
-  add_definitions(-DNDEBUG -D_WINDOWS -D_USRDLL)
-  add_compile_options(/W3 /Ox /Gy /Oi /TC)
-  
-  # Ref: https://skia.googlesource.com/third_party/sdl/+/refs/heads/master/CMakeLists.txt#225
-  # Make sure /RTC1 is disabled, otherwise it will use functions from the CRT
-  foreach(flag_var
-      CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
-      CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
-    string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
-  endforeach(flag_var)
+  add_definitions(-D_WINDOWS -D_USRDLL)
+
+  if(NOT CMAKE_BUILD_TYPE MATCHES Debug)
+    add_definitions(-DNDEBUG)
+    add_compile_options(/W3 /Ox /Gy /Oi /TC)
+    foreach(flag_var
+        CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
+        CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
+      string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
+    endforeach(flag_var)
+  endif()
 else()
-  add_compile_options(-Wall -O3)
+  add_compile_options(-Wall)
+
+  if(NOT CMAKE_BUILD_TYPE MATCHES Debug)
+    add_compile_options(-O3)
+  endif()
 endif()
 
 get_directory_property(hasParent PARENT_DIRECTORY)
@@ -88,8 +93,10 @@
   src/mat4x2.c
   src/mat4x3.c
   src/plane.c
+  src/noise.c
   src/frustum.c
   src/box.c
+  src/aabb2d.c
   src/project.c
   src/sphere.c
   src/ease.c

=== docs/requirements.txt ===
# Defining the exact version will make sure things don't break
sphinx==7.2.6
sphinx_rtd_theme==2.0.0
readthedocs-sphinx-search==0.3.2

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -5,11 +5,6 @@
   runner.c
   src/test_euler.c
   src/test_bezier.c
-  src/test_cam.c
-  src/test_cam_lh_zo.c
-  src/test_cam_rh_zo.c
-  src/test_cam_lh_no.c
-  src/test_cam_rh_no.c
   src/test_struct.c
   src/test_clamp.c
   src/test_common.c
@@ -21,6 +16,11 @@
 
 add_executable(${TEST_MAIN} ${TESTFILES})
 target_compile_definitions(${TEST_MAIN} PRIVATE CGLM_DEFINE_PRINTS=1)
+
+if(CMAKE_SYSTEM_NAME STREQUAL WASI)
+  target_compile_definitions(${TEST_MAIN} PRIVATE _WASI_EMULATED_PROCESS_CLOCKS=1)
+  target_link_options(${TEST_MAIN} PRIVATE "-lwasi-emulated-process-clocks")
+endif()
 
 if(NOT MSVC)
   target_link_libraries(${TEST_MAIN} PRIVATE m)

=== debian/changelog ===
cglm (0.9.6-1) unstable; urgency=medium

  * New upstream release
  * Update symbols file
  * d/control: Bump Standards-Version to 4.7.1
    - no changes needed
  * d/copyright: Update copyright year
  * Add Re-add-glm_vec3_step_uni-and-glm_vec4_step_uni.patch

 -- Leon Marz <main@lmarz.org>  Sat, 22 Feb 2025 12:19:00 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                meson,
                python3-sphinx,
                python3-sphinx-rtd-theme
-Standards-Version: 4.6.2
+Standards-Version: 4.7.1
 Section: libs
 Homepage: https://github.com/recp/cglm
 Vcs-Git: https://salsa.debian.org/debian/cglm.git

## cglm 1.0

=== DESCRIPTION ===
Package: cglm
Type: Package
Title: Fits Conditional Generalized Linear Models
Version: 1.0
Date: 2018-11-26
Author: Arvid Sjolander
Maintainer: Arvid Sjolander <arvid.sjolander@ki.se>
Description: Estimates the ratio of the regression coefficients and the dispersion parameter in conditional generalized linear models for clustered data.
License: GPL (>= 2)
Imports: Rcpp (>= 0.12.18), stats, nleqslv, data.table
LinkingTo: Rcpp, RcppArmadillo
NeedsCompilation: yes
Packaged: 2018-11-26 07:17:23 UTC; arvsjo
Repository: CRAN
Date/Publication: 2018-12-03 10:32:41 UTC

## cglm 1.1

=== DESCRIPTION ===
Package: cglm
Type: Package
Title: Fits Conditional Generalized Linear Models
Version: 1.1
Date: 2019-12-06
Author: Arvid Sjolander
Maintainer: Arvid Sjolander <arvid.sjolander@ki.se>
Description: Estimates the ratio of the regression coefficients and the dispersion parameter in conditional generalized linear models for clustered data.
License: GPL (>= 2)
Imports: Rcpp (>= 0.12.18), stats, nleqslv, data.table
LinkingTo: Rcpp, RcppArmadillo
NeedsCompilation: yes
Packaged: 2019-12-06 13:22:34 UTC; arvsjo
Repository: CRAN
Date/Publication: 2019-12-06 13:50:02 UTC
